# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' @name bgnbd_CET
#'
#' @templateVar name_model_full BG/NBD
#' @templateVar name_model_short bgnbd
#' @template template_titledescriptionreturn_CET
#'
#' @template template_params_bgnbd
#' @template template_params_rcppperiods
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#' @template template_params_rcppvcovparams
#'
#' @templateVar name_params_cov_life vCovParams_life
#' @templateVar name_params_cov_trans vCovParams_trans
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_bgnbd
#'
NULL

#' @rdname bgnbd_CET
bgnbd_nocov_CET <- function(r, alpha, a, b, dPeriods, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_bgnbd_nocov_CET`, r, alpha, a, b, dPeriods, vX, vT_x, vT_cal)
}

#' @rdname bgnbd_CET
bgnbd_staticcov_CET <- function(r, alpha, a, b, dPeriods, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_trans, mCov_life) {
    .Call(`_CLVTools_bgnbd_staticcov_CET`, r, alpha, a, b, dPeriods, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_trans, mCov_life)
}

#' @name bgnbd_LL
#'
#' @templateVar name_model_full BG/NBD
#' @templateVar name_model_short bgnbd
#' @templateVar model_params_ordered r, alpha_0, a, b
#' @template template_titleparamsdescriptionreturndetails_LL
#'
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#'
#' @templateVar name_params_cov_life vLogparams
#' @templateVar name_params_cov_trans vLogparams
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_bgnbd
#'
NULL

#' @rdname bgnbd_LL
bgnbd_nocov_LL_ind <- function(vLogparams, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_bgnbd_nocov_LL_ind`, vLogparams, vX, vT_x, vT_cal)
}

#' @rdname bgnbd_LL
bgnbd_nocov_LL_sum <- function(vLogparams, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_bgnbd_nocov_LL_sum`, vLogparams, vX, vT_x, vT_cal)
}

#' @rdname bgnbd_LL
bgnbd_staticcov_LL_ind <- function(vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans) {
    .Call(`_CLVTools_bgnbd_staticcov_LL_ind`, vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans)
}

#' @rdname bgnbd_LL
bgnbd_staticcov_LL_sum <- function(vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans) {
    .Call(`_CLVTools_bgnbd_staticcov_LL_sum`, vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans)
}

#' @name bgnbd_PAlive
#'
#' @templateVar name_model_full BG/NBD
#' @templateVar name_model_short bgnbd
#' @template template_titledescriptionreturn_palive
#'
#' @template template_params_bgnbd
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#' @template template_params_rcppvcovparams
#'
#' @templateVar name_params_cov_life vCovParams_life
#' @templateVar name_params_cov_trans vCovParams_trans
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_bgnbd
#'
NULL

#' @rdname bgnbd_PAlive
bgnbd_nocov_PAlive <- function(r, alpha, a, b, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_bgnbd_nocov_PAlive`, r, alpha, a, b, vX, vT_x, vT_cal)
}

#' @rdname bgnbd_PAlive
bgnbd_staticcov_PAlive <- function(r, alpha, a, b, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_trans, mCov_life) {
    .Call(`_CLVTools_bgnbd_staticcov_PAlive`, r, alpha, a, b, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_trans, mCov_life)
}

#' @title GSL Hypergeom 2f0 for equal length vectors
#'
#' @param vA Vector of values for parameter a
#' @param vB Vector of values for parameter b
#' @param vZ Vector of values for parameter z
#'
#' @description Calculate the hypergeometric 2f0 using the GSL library (gsl_sf_hyperg_2F0_e)
#' @return List with vector of values and vector of gsl status codes
#' @keywords internal
vec_gsl_hyp2f0_e <- function(vA, vB, vZ) {
    .Call(`_CLVTools_vec_gsl_hyp2f0_e`, vA, vB, vZ)
}

#' @title GSL Hypergeom 2f1 for equal length vectors
#'
#' @param vA Vector of values for parameter a
#' @param vB Vector of values for parameter b
#' @param vC Vector of values for parameter c
#' @param vZ Vector of values for parameter z
#'
#' @description Calculate the hypergeometric 2f1 using the GSL library (gsl_sf_hyperg_2F1_e)
#' @return List with vector of values and vector of gsl status codes
#' @keywords internal
vec_gsl_hyp2f1_e <- function(vA, vB, vC, vZ) {
    .Call(`_CLVTools_vec_gsl_hyp2f1_e`, vA, vB, vC, vZ)
}

#' @title Gamma-Gamma: Log-Likelihood Function
#'
#' @description
#' Calculates the Log-Likelihood value for the Gamma-Gamma model.
#'
#' @param vLogparams a vector containing the log of the parameters p, q, gamma
#' @param vX frequency vector of length n counting the numbers of purchases
#' @param vM_x the observed average spending for every customer during the calibration time.
#'
#' @details
#' \code{vLogparams} is a vector with the parameters for the Gamma-Gamma model.
#' It has three parameters (p, q, gamma). The scale parameter for each transaction
#' is distributed across customers according to a gamma distribution with
#' parameters q (shape) and gamma (scale).
#'
#'@return
#' Returns the Log-Likelihood value for the Gamma-Gamma model.
#'
#' @template template_references_gg
#'
#'
gg_LL <- function(vLogparams, vX, vM_x) {
    .Call(`_CLVTools_gg_LL`, vLogparams, vX, vM_x)
}

#' @name ggomnbd_CET
#'
#' @templateVar name_model_full GGompertz/NBD
#' @templateVar name_model_short ggomnbd
#' @template template_titledescriptionreturn_CET
#'
#' @template template_params_ggomnbd
#' @template template_params_rcppperiods
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#' @template template_params_rcppvcovparams
#'
#' @templateVar name_params_cov_life vCovParams_life
#' @templateVar name_params_cov_trans vCovParams_trans
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_ggomnbd
#'
NULL

#' @rdname ggomnbd_CET
ggomnbd_nocov_CET <- function(r, alpha_0, b, s, beta_0, dPeriods, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_ggomnbd_nocov_CET`, r, alpha_0, b, s, beta_0, dPeriods, vX, vT_x, vT_cal)
}

#' @rdname ggomnbd_CET
ggomnbd_staticcov_CET <- function(r, alpha_0, b, s, beta_0, dPeriods, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_life, mCov_trans) {
    .Call(`_CLVTools_ggomnbd_staticcov_CET`, r, alpha_0, b, s, beta_0, dPeriods, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_life, mCov_trans)
}

#' @name ggomnbd_LL
#'
#' @templateVar name_model_full GGompertz/NBD
#' @templateVar name_model_short ggomnbd
#' @templateVar model_params_ordered r, alpha_0, b, s, beta_0
#' @template template_titleparamsdescriptionreturndetails_LL
#'
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#'
#' @templateVar name_params_cov_life vParams
#' @templateVar name_params_cov_trans vParams
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_ggomnbd
#'
NULL

#' @rdname ggomnbd_LL
ggomnbd_nocov_LL_ind <- function(vLogparams, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_ggomnbd_nocov_LL_ind`, vLogparams, vX, vT_x, vT_cal)
}

#' @rdname ggomnbd_LL
ggomnbd_nocov_LL_sum <- function(vLogparams, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_ggomnbd_nocov_LL_sum`, vLogparams, vX, vT_x, vT_cal)
}

#' @rdname ggomnbd_LL
ggomnbd_staticcov_LL_ind <- function(vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans) {
    .Call(`_CLVTools_ggomnbd_staticcov_LL_ind`, vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans)
}

#' @rdname ggomnbd_LL
ggomnbd_staticcov_LL_sum <- function(vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans) {
    .Call(`_CLVTools_ggomnbd_staticcov_LL_sum`, vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans)
}

#' @name ggomnbd_PAlive
#'
#' @templateVar name_model_full GGompertz/NBD
#' @templateVar name_model_short ggomnbd
#' @template template_titledescriptionreturn_palive
#'
#' @template template_params_ggomnbd
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#' @template template_params_rcppvcovparams
#'
#' @templateVar name_params_cov_life vCovParams_life
#' @templateVar name_params_cov_trans vCovParams_trans
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_ggomnbd
#'
NULL

#' @rdname ggomnbd_PAlive
ggomnbd_staticcov_PAlive <- function(r, alpha_0, b, s, beta_0, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_life, mCov_trans) {
    .Call(`_CLVTools_ggomnbd_staticcov_PAlive`, r, alpha_0, b, s, beta_0, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_life, mCov_trans)
}

#' @rdname ggomnbd_PAlive
ggomnbd_nocov_PAlive <- function(r, alpha_0, b, s, beta_0, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_ggomnbd_nocov_PAlive`, r, alpha_0, b, s, beta_0, vX, vT_x, vT_cal)
}

#' @name ggomnbd_expectation
#' @title GGompertz/NBD: Unconditional Expectation
#'
#' @description Computes the expected number of repeat transactions in the interval (0, vT_i]
#' for a randomly selected customer, where 0 is defined as the point when the customer came alive.
#'
#' @template template_params_ggomnbd
#' @param vT_i Number of periods since the customer came alive
#' @template template_params_rcppcovmatrix
#' @template template_params_rcppvcovparams
#'
#' @templateVar name_params_cov_life vCovParams_life
#' @templateVar name_params_cov_trans vCovParams_trans
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_ggomnbd
#'
NULL

#' @rdname ggomnbd_expectation
ggomnbd_nocov_expectation <- function(r, alpha_0, b, s, beta_0, vT_i) {
    .Call(`_CLVTools_ggomnbd_nocov_expectation`, r, alpha_0, b, s, beta_0, vT_i)
}

#' @rdname ggomnbd_expectation
ggomnbd_staticcov_expectation <- function(r, alpha_0, b, s, beta_0, vT_i, vCovParams_trans, vCovParams_life, mCov_life, mCov_trans) {
    .Call(`_CLVTools_ggomnbd_staticcov_expectation`, r, alpha_0, b, s, beta_0, vT_i, vCovParams_trans, vCovParams_life, mCov_life, mCov_trans)
}

#' @name pnbd_CET
#'
#' @templateVar name_model_full Pareto/NBD
#' @templateVar name_model_short pnbd
#' @template template_titledescriptionreturn_CET
#'
#' @template template_params_pnbd
#' @template template_params_rcppperiods
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#' @template template_params_rcppvcovparams
#'
#' @templateVar name_params_cov_life vCovParams_life
#' @templateVar name_params_cov_trans vCovParams_trans
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_pnbd
#'
NULL

#' @rdname pnbd_CET
pnbd_nocov_CET <- function(r, alpha_0, s, beta_0, dPeriods, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_pnbd_nocov_CET`, r, alpha_0, s, beta_0, dPeriods, vX, vT_x, vT_cal)
}

#' @rdname pnbd_CET
pnbd_staticcov_CET <- function(r, alpha_0, s, beta_0, dPeriods, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_trans, mCov_life) {
    .Call(`_CLVTools_pnbd_staticcov_CET`, r, alpha_0, s, beta_0, dPeriods, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_trans, mCov_life)
}

#' @name pnbd_DERT
#'
#' @title Pareto/NBD: Discounted Expected Residual Transactions
#'
#' @description
#' Calculates the discounted expected residual transactions.
#'
#' \itemize{
#' \item{\code{pnbd_nocov_DERT}}{ Discounted expected residual transactions for the Pareto/NBD model without covariates}
#' \item{\code{pnbd_staticcov_DERT}}{ Discounted expected residual transactions for the Pareto/NBD model with static covariates}
#' }
#'
#' @template template_params_pnbd
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#' @template template_params_rcppvcovparams
#' @param continuous_discount_factor continuous discount factor to use
#'
#'
#' @templateVar name_params_cov_life vCovParams_life
#' @templateVar name_params_cov_trans vCovParams_trans
#' @template template_details_rcppcovmatrix
#'
#' @return
#' Returns a vector with the DERT for each customer.
#'
#' @template template_references_pnbd
#'
#'
NULL

#' @rdname pnbd_DERT
pnbd_nocov_DERT <- function(r, alpha_0, s, beta_0, continuous_discount_factor, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_pnbd_nocov_DERT`, r, alpha_0, s, beta_0, continuous_discount_factor, vX, vT_x, vT_cal)
}

#' @rdname pnbd_DERT
pnbd_staticcov_DERT <- function(r, alpha_0, s, beta_0, continuous_discount_factor, vX, vT_x, vT_cal, mCov_life, mCov_trans, vCovParams_life, vCovParams_trans) {
    .Call(`_CLVTools_pnbd_staticcov_DERT`, r, alpha_0, s, beta_0, continuous_discount_factor, vX, vT_x, vT_cal, mCov_life, mCov_trans, vCovParams_life, vCovParams_trans)
}

#' @name pnbd_LL
#'
#' @templateVar name_model_full Pareto/NBD
#' @templateVar name_model_short pnbd
#' @templateVar model_params_ordered r, alpha_0, s, beta_0
#' @template template_titleparamsdescriptionreturndetails_LL
#'
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#'
#' @templateVar name_params_cov_life vParams
#' @templateVar name_params_cov_trans vParams
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_pnbd
#'
NULL

#' @rdname pnbd_LL
pnbd_nocov_LL_ind <- function(vLogparams, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_pnbd_nocov_LL_ind`, vLogparams, vX, vT_x, vT_cal)
}

#' @rdname pnbd_LL
pnbd_nocov_LL_sum <- function(vLogparams, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_pnbd_nocov_LL_sum`, vLogparams, vX, vT_x, vT_cal)
}

#' @rdname pnbd_LL
pnbd_staticcov_LL_ind <- function(vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans) {
    .Call(`_CLVTools_pnbd_staticcov_LL_ind`, vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans)
}

#' @rdname pnbd_LL
pnbd_staticcov_LL_sum <- function(vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans) {
    .Call(`_CLVTools_pnbd_staticcov_LL_sum`, vParams, vX, vT_x, vT_cal, mCov_life, mCov_trans)
}

#' @name pnbd_PAlive
#'
#' @templateVar name_model_full Pareto/NBD
#' @templateVar name_model_short pnbd
#' @template template_titledescriptionreturn_palive
#'
#' @template template_params_pnbd
#' @template template_params_rcppxtxtcal
#' @template template_params_rcppcovmatrix
#' @template template_params_rcppvcovparams
#'
#' @templateVar name_params_cov_life vCovParams_life
#' @templateVar name_params_cov_trans vCovParams_trans
#' @template template_details_rcppcovmatrix
#'
#' @template template_references_pnbd
#'
NULL

#' @rdname pnbd_PAlive
pnbd_nocov_PAlive <- function(r, alpha_0, s, beta_0, vX, vT_x, vT_cal) {
    .Call(`_CLVTools_pnbd_nocov_PAlive`, r, alpha_0, s, beta_0, vX, vT_x, vT_cal)
}

#' @rdname pnbd_PAlive
pnbd_staticcov_PAlive <- function(r, alpha_0, s, beta_0, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_trans, mCov_life) {
    .Call(`_CLVTools_pnbd_staticcov_PAlive`, r, alpha_0, s, beta_0, vX, vT_x, vT_cal, vCovParams_trans, vCovParams_life, mCov_trans, mCov_life)
}

