% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class_clv_pnbd_staticcov.R
\docType{class}
\name{clv.pnbd.static.cov-class}
\alias{clv.pnbd.static.cov-class}
\title{Result of fitting the Pareto/NBD model with static covariates}
\description{
Output from fitting the Pareto/NBD model on data with static covariates. It constitutes the
estimation result and is returned to the user to use it as input to other methods such as
to make predictions or plot the unconditional expectation.

Inherits from \code{clv.fitted.static.cov} in order to execute all steps required for fitting a model
with static covariates and it contains an instance of class \code{clv.model.pnbd.static.cov} which
provides the required Pareto/NBD (static covariates) specific functionalities.
}
\section{Slots}{

\describe{
\item{\code{cbs}}{Single \code{data.table} that is the Customer-By-Sufficiency matrix with information about
each customers' recency, frequency, and total time observed in number of time-units
and as defined by the Pareto/NBD model.}
}}

\seealso{
\link{clv.fitted.static.cov-class}, \link{clv.model.pnbd.static.cov-class}, \link{clv.pnbd-class}, \link{clv.pnbd.dynamic.cov-class}
}
\keyword{internal}
